<?php

    $fufu_config = json_decode(file_get_contents(ROOT_DIR.'/ninja-applications/fufu/lib/config.fufu.inc'), true);
    $fufu_user_config = json_decode(file_get_contents(ROOT_DIR.'/ninja-applications/fufu/lib/config.fufu_user.inc'), true);

    if($fufu_config['l_choose'] == '1' && (isset($_COOKIE['fufu_locale']) && $_COOKIE['fufu_locale'] != '') && file_exists(ROOT_DIR.'/ninja-applications/fufu/locales/'.$_COOKIE['fufu_locale'])){ 
        $fufu_config['locale'] = $_COOKIE['fufu_locale'];
    }
    if($fufu_config['t_choose'] == '1' && (isset($_COOKIE['fufu_theme']) && $_COOKIE['fufu_theme'] != '') && file_exists(ROOT_DIR.'/ninja-applications/fufu/themes/'.$_COOKIE['fufu_theme'])){ 
        $fufu_config['theme'] = $_COOKIE['fufu_theme'];
    }

    // Language
    $lang = array_merge($lang, json_decode(file_get_contents(ROOT_DIR.'/ninja-applications/fufu/locales/'.$fufu_config['locale']), true));
    // THEME SETTING IF EXIST
    if(file_exists(ROOT_DIR.'/ninja-applications/fufu/themes/'.$fufu_config['theme'].'/libs/config.theme.inc')){
        $fufu_theme = json_decode(file_get_contents(ROOT_DIR.'/ninja-applications/fufu/themes/'.$fufu_config['theme'].'/libs/config.theme.inc'), true);
    }


    // GET IMPORTANT SLUG
    $fufu_slug = array();
    $ninja->db->limit_val = "";
    $fufu_important_slug = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."slug",array('slug','page'),array('application'=>'fufu','important'=>'1')); 
    if(count($fufu_important_slug) > 0){
        foreach($fufu_important_slug as &$slug){
            $fufu_slug[$slug['page']] = $slug['slug'];
        }
    }

    class ninja_fufu extends ninja{
        var $lang = '';
        var $fufu_config = array();
        var $fufu_user_config = array();
        var $fufu_theme = array();
        var $fufu_slug = array();

        public function setLang(array $lang) {
            $this->lang = $lang;
        }

        public function setConfig(array $array) {
            $this->fufu_config = $array;
        }

        public function setUserConfig(array $array) {
            $this->fufu_user_config = $array;
        }

        public function setSlug(array $array) {
            $this->fufu_slug = $array;
        }

        public function setThemeConfig(array $array) {
            $this->fufu_theme = $array;
        }

        function store_view_logs($fuId){
            $this->db->limit_val = "1";
            $day = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."fufu_view_logs",'', array("fuId"=>$fuId,'type'=>'d','val'=>date('z'),'year'=>date('Y') ));
            $week = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."fufu_view_logs",'', array("fuId"=>$fuId,'type'=>'w','val'=>date('W'),'year'=>date('Y') ));
            $month = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."fufu_view_logs",'', array("fuId"=>$fuId,'type'=>'m','val'=>date('n'),'year'=>date('Y') ));
            ///////////////////// DAY ///////////////////////
            if(count($day) < 1){  
                $insert = $this->db->dbInsert($this->ninja_config['TABLES_PREFIX']."fufu_view_logs",array("fuId"=>$fuId,'views'=>'1','type'=>'d','val'=>date('z'),'year'=>date('Y')));
            }else{
                $update = $this->db->dbUpdate($this->ninja_config['TABLES_PREFIX']."fufu_view_logs",array('views'=>$day[0]['views']+1),array('type'=>'d','val'=>date('z'),'year'=>date('Y') ) );
            }
            ///////////////////// WEEK ///////////////////////
            if(count($week) < 1){  
                $insert = $this->db->dbInsert($this->ninja_config['TABLES_PREFIX']."fufu_view_logs",array("fuId"=>$fuId,'views'=>'1','type'=>'w','val'=>date('W'),'year'=>date('Y')));
            }else{
                $update = $this->db->dbUpdate($this->ninja_config['TABLES_PREFIX']."fufu_view_logs",array('views'=>$week[0]['views']+1),array("fuId"=>$fuId,'type'=>'w','val'=>date('W'),'year'=>date('Y')));
            }
            ///////////////////// MONTH ///////////////////////
            if(count($month) < 1){  
                $insert = $this->db->dbInsert($this->ninja_config['TABLES_PREFIX']."fufu_view_logs",array("fuId"=>$fuId,'views'=>'1','type'=>'m','val'=>date('n'),'year'=>date('Y')));
            }else{
                $update = $this->db->dbUpdate($this->ninja_config['TABLES_PREFIX']."fufu_view_logs",array('views'=>$month[0]['views']+1),array("fuId"=>$fuId,'type'=>'m','val'=>date('n'),'year'=>date('Y')));
            }
            return $this->db->error_info;
        }

        function fuOwner($uId){
            $this->db->limit_val = "1";
            $result = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."users",array("id","avatar","username"),array("id"=>$uId));
            if(count($result) > 0){
                return $result[0];
            }
            return NULL;
        }

        function theme_list(){
            if ($handle = opendir(ROOT_DIR.'/ninja-applications/fufu/themes/')) {
                while (false !== ($entry = readdir($handle))) {
                    if ($entry != "." && $entry != "..") {
                        echo "<option value='$entry' ".($entry == $this->fufu_config['theme'] ? 'selected' : '').">".ucfirst($entry)."</option>";
                    }
                }
                closedir($handle);
           }
        }

        function locale_list(){
            if ($handle = opendir(ROOT_DIR.'/ninja-applications/fufu/locales/')) {
                while (false !== ($entry = readdir($handle))) {
                    if ($entry != "." && $entry != "..") {
                        echo "<option value='$entry' ".($entry == $this->fufu_config['locale'] ? 'selected' : '').">".ucfirst(str_replace('.php', '', $entry))."</option>";
                    }
                }
                closedir($handle);
           }
        }
        function do_rate($rate){
            return $rate > 0 ? '+'.$rate : $rate;
        }
        function cat_is_exist($cat_id){
            $this->db->limit_val="1";
            $fufu_cat = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."fufu_cat",array("cat_id"),array("cat_id"=>$cat_id)); 
            if(count($fufu_cat) > 0){
                return true;
            } 
            return false;
        }
        function do_cat($cat_id){
            $this->db->order_by_column = "";
            $this->db->limit_val="1";
            $fufu_cat = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."fufu_cat",array("name","cat_id"),array("cat_id"=>$cat_id)); 
            if(count($fufu_cat) > 0){ 
                return $fufu_cat[0]['name'];
            }else{
                return $this->lang['No-category'];
            }                        
        }

        function gen_6slug(){
            $six_slug = uniqid(rand(10,1000),false);
            $six_slug = substr($six_slug,rand(0,strlen($six_slug) - 6),6);
            if($this->slugIsExist('/'.$six_slug)){
                return $this->gen_6slug();
            }else{
                return $six_slug;
            }
        }

        function get_vine_thumbnail($url){
            $vine = file_get_contents($url);
            preg_match('/property="og:image" content="(.*?)"/', $vine, $matches);

            return ($matches[1]) ? $matches[1] : false;
        }

        function print_cat_selections($thisCat = NULL){
            $this->db->limit_val='';
            $fufu_cat = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."fufu_cat",array("name","cat_id")); 
            if(count($fufu_cat) > 0){ 
                foreach($fufu_cat as &$cat){
                    if(isset($thisCat) && $cat['cat_id'] == $thisCat){ $selected = 'selected'; }else{ $selected = ''; }
                    echo '<option value="'.$cat['cat_id'].'" '.$selected.'>'.$cat['name'].'</option>';
                }
            }else{
                return $this->lang['No-category'];
            }                        

        }
        function print_nsfw_cat_selections(){
            $this->db->limit_val='';
            $fufu_cat = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."fufu_cat",array("name","cat_id")); 
            if(count($fufu_cat) > 0){ 
                foreach($fufu_cat as &$cat){
                    $selected = isset($this->fufu_config['nsfw_cat']) && in_array($cat['cat_id'], $this->fufu_config['nsfw_cat']) ? 'selected' : '';
                    echo '<option value="'.$cat['cat_id'].'" '.$selected.'>'.$cat['name'].'</option>';
                }
            }else{
                return $this->lang['No-category'];
            }                        

        }
        function print_sociallock_cat_selections(){
            $this->db->limit_val='';
            $fufu_cat = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."fufu_cat",array("name","cat_id")); 
            if(count($fufu_cat) > 0){ 
                foreach($fufu_cat as &$cat){
                    $selected = isset($this->fufu_config['sociallock_cat']) && in_array($cat['cat_id'], $this->fufu_config['sociallock_cat']) ? 'selected' : '';
                    echo '<option value="'.$cat['cat_id'].'" '.$selected.'>'.$cat['name'].'</option>';
                }
            }else{
                return $this->lang['No-category'];
            }                        

        }
        function do_fu_description($input){
            $output = stripslashes($input);
            $output = preg_replace( "/#(\w+)/u", "<a href=\"".$this->ninja_config['siteUrl'].$this->fufu_slug['index']."?q=%23$1\">#$1</a>", $output );
            $output = nl2br($output);
            return $output;
        }
        function do_fu($fu){
            if($fu['fu_type'] == 'img'){
                $string = '<img src="'.$this->ninja_config['siteUrl'].$fu['original_img'].'" class="fu-img" style="width: '.$this->fufu_theme['img_width'].'">';
            }else if($fu['fu_type'] == 'gallery'){
                $imgs = $fu['embed'];
                $imgs = rtrim($imgs, ';');
                $imgs = explode(';', $imgs);
                $string = '<ul class="bxslider">';
                foreach ($imgs as &$img) {
                    $string .= '<li><img src="'.$this->ninja_config['siteUrl'] . $img . '" class="fu-img" style="width: 100%"></li>';
                }
                $string .= '</ul>';
            }else if($fu['fu_type'] == 'video'){
                $string = strtr($fu['iframe'], array('{{height}}'=>$this->fufu_theme['video_height'],'{{width}}'=>$this->fufu_theme['video_width']));
            }else if($fu['fu_type'] == 'vine'){
                $string = strtr($fu['iframe'], array('{{height}}'=>$this->fufu_theme['vine_width'],'{{width}}'=>$this->fufu_theme['vine_width']));
                $string = str_replace('id="vine"', 'class="vine-embed"', $string);
                $string .= '
                      <script>
                      var cw = $(\'#vine\').width();
                      $(\'#vine\').height(cw);
                      var cw2 = $(\'.vine-embed\').width();
                      $(\'.vine-embed\').height(cw2);
                      </script>';
            }else if($fu['fu_type'] == 'soundcloud'){
                $string = strtr($fu['iframe'], array('{{height}}'=>$this->fufu_theme['video_width'],'{{width}}'=>$this->fufu_theme['video_width']));
            }else{
                $string = '<img src="'.$this->ninja_config['siteUrl'].$fu['original_img'].'" class="fu-img" style="width: '.$this->fufu_theme['gif_width'].'">';
            }
            return $string;
        }

        function log_recent_tags($tag, $n = 10){
            $this->db->limit_val = '1';
            $tags = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."fufu_recent_tags", "text", array('id'=>1));
            $this->db->limit_val = '';
            $tags = $tags[0]["text"];
            $tags = rtrim($tags, ';');
            $tags = explode(';', $tags);
            if (in_array($tag, $tags)) {
                $tags = array_diff($tags, array($tag));
                array_unshift($tags, $tag);
            }else{
                array_unshift($tags, $tag);
            }
            $tags = array_splice($tags, 0, $n);
            $tags = implode(";", $tags);
            $this->db->dbUpdate($this->ninja_config['TABLES_PREFIX']."fufu_recent_tags", array("text"=>$tags),array("id"=>1));
        }

        function get_recent_tags($n){
            // GET LIST OF RECENT TAGS USED AND RETURN AS AN ARRAY
            $this->db->limit_val = '1';
            $tags = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."fufu_recent_tags", "text", array('id'=>1));
            $this->db->limit_val = '';
            $tags = $tags[0]["text"];
            $tags = rtrim($tags, ';');
            $tags = explode(';', $tags);
            return $tags;
        }

        function time_elapsed_string($datetime, $full = false) {
            $now = new DateTime;
            $ago = new DateTime($datetime);
            $diff = $now->diff($ago);

            $string = array(
                'y' => $this->lang['year'],
                'm' => $this->lang['month'],
                'd' => $this->lang['day'],
                'h' => $this->lang['hour'],
                'i' => $this->lang['minute'],
                's' => $this->lang['second'],
            );
            foreach ($string as $k => &$v) {
                if ($diff->$k) {
                    $v = $diff->$k . ' ' . $v . ($diff->$k > 1 ? $this->lang['time-period-s'] : '');
                } else {
                    unset($string[$k]);
                }
            }

            if (!$full) $string = array_slice($string, 0, 1);
            return $string ? implode(', ', $string) . ' '.$this->lang['ago'] : $this->lang['just-now'];
        }
        function getHashtags($string) {  
            $hashtags= FALSE;  
            preg_match_all("/(#\w+)/u", $string, $matches);  
            if ($matches) {
                $hashtagsArray = array_count_values($matches[0]);
                $hashtags = array_keys($hashtagsArray);
            }
            return $hashtags;
        }
        function visitor_theme_chooser(){
            if ($handle = opendir(ROOT_DIR.'/ninja-applications/fufu/themes/')) {
                while (false !== ($entry = readdir($handle))) {
                    if ($entry != "." && $entry != "..") {
                        echo '<li><a href="javascript:;" class="theme-chooser" data-value="'.$entry.'" data-href="'.$this->ninja_config['siteUrl'].'/ninja-applications/fufu/controllers/cont.changetheme.php">'.ucfirst($entry).'</a></li>';
                    }
                }
                closedir($handle);
           }
        }
        function visitor_locale_chooser(){
            if ($handle = opendir(ROOT_DIR.'/ninja-applications/fufu/locales/')) {
                while (false !== ($entry = readdir($handle))) {
                    if ($entry != "." && $entry != "..") {
                        echo '<li><a href="javascript:;" class="locale-chooser" data-value="'.$entry.'" data-href="'.$this->ninja_config['siteUrl'].'/ninja-applications/fufu/controllers/cont.changelocale.php">'.ucfirst($entry).'</a></li>';
                    }
                }
                closedir($handle);
           }
        }
        function get_top_fu($type, $limit){
            /// $type = 'month', 'week', 'day'
            $trans = array("day" => "d", "month" => "m", "week" => "w");
            $type = strtr($type, $trans);
            $this->db->limit_val = $limit;
            $this->db->order_by_column = "views DESC";
            $topFuIdArr = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."fufu_view_logs", array("fuId"),
                                array('type'=>$type,
                                      "year"=>date('Y'))
                                );  
            if(!is_array($topFuIdArr) || count($topFuIdArr) < 2){
                $this->db->order_by_column = '';
                $this->db->limit_val = ''; 
                $this->db->group_by_column = ''; 
            }else{
                $tables = array($this->ninja_config['TABLES_PREFIX']."fufu_fu", $this->ninja_config['TABLES_PREFIX']."slug");
                $joins = array($this->ninja_config['TABLES_PREFIX']."fufu_fu.f_id=".$this->ninja_config['TABLES_PREFIX']."slug.c_id");
                $joinCondition = array("LEFT JOIN");
                $whereCondition = array($this->ninja_config['TABLES_PREFIX']."slug.page"=>"display_fu",$this->ninja_config['TABLES_PREFIX']."slug.important"=>"0",$this->ninja_config['TABLES_PREFIX']."fufu_fu.isapproved"=>"1");
                $this->db->in=array("f_id"=>"'".implode("','",$this->array_value_recursive('fuId',$topFuIdArr))."'");          
                $columns = array("f_id","slug","title","fu_type","thumbnail_img","original_img"); 
                $fuArray = $this->db->dbSelectJoin($tables,$joins,$joinCondition,$columns,$whereCondition); 
                $this->db->in = '';
                $this->db->order_by_column = '';
                $this->db->limit_val = ''; 
                $this->db->group_by_column = ''; 
                return $fuArray;
            }
        } 

        function get_trending($timelimit, $limit){ 
            // timelimit = month, week, day
            $CurrentTime = new DateTime();
            $time2Check = new DateTime();
            if($timelimit == 'week'){
                $time2Check->modify('-1 week');
            }else if($timelimit == 'month'){
                $time2Check->modify('-1 month');
            }else{
                $time2Check->modify('-1 day');
            }
            // GET TRENDING FU
            $this->db->limit_val = $limit;
            $this->db->group_by_column="f_id"; 
            //$this->db->backticks="";   
            $this->db->order_by_column = "SUM(f_id) DESC";
            $trendingArr = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."fufu_votelog", array("f_id"),
                                array('did'=>'1',
                                      "date >="=>$time2Check->format('Y-m-d H:i:s'),
                                      "date <="=>$CurrentTime->format('Y-m-d H:i:s'))
                                );  
            if(count($trendingArr) < 2){
                $this->db->in = '';
                $this->db->order_by_column = '';
                $this->db->limit_val = ''; 
                $this->db->group_by_column = ''; 
                return NULL;
            }else{
                $tables = array($this->ninja_config['TABLES_PREFIX']."fufu_fu", $this->ninja_config['TABLES_PREFIX']."slug");
                $joins = array($this->ninja_config['TABLES_PREFIX']."fufu_fu.f_id=".$this->ninja_config['TABLES_PREFIX']."slug.c_id");
                $joinCondition = array("LEFT JOIN");
                $whereCondition = array($this->ninja_config['TABLES_PREFIX']."slug.page"=>"display_fu",$this->ninja_config['TABLES_PREFIX']."slug.important"=>"0",$this->ninja_config['TABLES_PREFIX']."fufu_fu.isapproved"=>"1");
                $this->db->in=array("f_id"=>"'".implode("','",$this->array_value_recursive('f_id',$trendingArr))."'");          
                $columns = array("f_id","slug","title","fu_type","thumbnail_img","original_img"); 
                $fuArray = $this->db->dbSelectJoin($tables,$joins,$joinCondition,$columns,$whereCondition); 
                $this->db->in = '';
                $this->db->order_by_column = '';
                $this->db->limit_val = ''; 
                $this->db->group_by_column = ''; 
                return $fuArray;
            }
        }

        function get_top_user($type, $count){
            // TYPE: POINT, JOINDATE // COUNT: HOW MANY? 
                if($type == 'point'){
                    $this->db->order_by_column = 'point DESC';
                }elseif($type == 'joindate'){
                    $this->db->order_by_column = 'register_date DESC';
                }
                $this->db->limit_val = $count; 
                $tables = array($this->ninja_config['TABLES_PREFIX']."fufu_user", $this->ninja_config['TABLES_PREFIX']."users");
                $joins = array($this->ninja_config['TABLES_PREFIX']."fufu_user.user_id=".$this->ninja_config['TABLES_PREFIX']."users.id");
                $joinCondition = array("LEFT JOIN");       
                $columns = ''; 
                $userArray = $this->db->dbSelectJoin($tables,$joins,$joinCondition,$columns); 
                $this->db->in = '';
                $this->db->order_by_column = '';
                $this->db->limit_val = ''; 
                $this->db->group_by_column = ''; 
                return $userArray;
        }

        function random_fu(){
            $this->db->limit_val = '1';
            $this->db->order_by_column = "RAND()";
            $result = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."slug",array("slug"),array("page"=>"display_fu"));   
            if(count($result) > 0){ 
                return $result[0]['slug'];
            }else{ 
                return NULL; 
            }
        }

        function add_point($userid, $point){
            $query = "UPDATE ".$this->ninja_config['TABLES_PREFIX']."fufu_user SET point=point+? WHERE user_id = ?";
            $this->db->dbExecuteQuery($query,array($point,$userid)); 
            if(isset($_SESSION['uId']) && $userid == $_SESSION['uId']){
                unset($_SESSION['thisUser']['point']);
            }
        }
        function minus_point($userid, $point){
            $query = "UPDATE ".$this->ninja_config['TABLES_PREFIX']."fufu_user SET point=point-? WHERE user_id = ?";
            $this->db->dbExecuteQuery($query,array($point,$userid)); 
            if(isset($_SESSION['uId']) && $userid == $_SESSION['uId']){
                unset($_SESSION['thisUser']['point']);
            }
        }
        function sendNoti($userid,$content,$href = ''){
            $this->db->dbInsert($this->ninja_config['TABLES_PREFIX']."fufu_user_notification",
                                array("user_id"=>$userid,"href"=>$href,"content"=>$content,"dateadded"=>date('Y-m-d H:i:s'),"isread"=>"0")); 
            //echo $this->db->error_info;
        }
        function user_comment($userid){
            $this->db->limit_val = '1';
            $result = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."users",
                                array('displayname','avatar','username'),
                                array("id"=>$userid)
                                ); 
            if(count($result) > 0){
                return $result[0];
            }
            return array();
            //echo $this->db->error_info;
        }
        function is_comment_exist($id){
            $this->db->limit_val = '1';
            $result = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."fufu_comments",
                                array('fu_id'),
                                array("id"=>$id)
                                ); 
            if(count($result) > 0){
                return true;
            }
            return false;
            //echo $this->db->error_info;
        }
        function is_fu_exist($id){
            $this->db->limit_val = '1';
            $result = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."fufu_fu",
                                array('f_id'),
                                array("f_id"=>$id)
                                ); 
            if(count($result) > 0){
                return true;
            }
            return false;
            //echo $this->db->error_info;
        }

        // CUSTOM FUNCTIONS GO HERE

    }

    // outside function


    $ninja_fufu = new ninja_fufu($ninja_config);
    $ninja_fufu->setLang($lang);
    $ninja_fufu->setConfig($fufu_config);
    $ninja_fufu->setUserConfig($fufu_user_config);
    $ninja_fufu->setSlug($fufu_slug);
    $ninja_fufu->setThemeConfig($fufu_theme);

    // CHECK IF USER ALREADY HAD A POINT TABLE OR NOT
    if($fufu_config['is_user'] == '1' && isset($_SESSION['thisUser'])){
        $ninja->db->limit_val = '1';
        $result = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."fufu_user",array("user_id"),array("user_id"=>$_SESSION['thisUser']['id'])); 
        if(count($result) < 1){
            $ninja->db->dbInsert($ninja_config['TABLES_PREFIX']."fufu_user",array("user_id"=>$_SESSION['thisUser']['id'],"point"=>"0","badge"=>"{\"\":\"\"}")); 
        }
        $_SESSION['pointed'] = 1;
    }  
    // CHECK IF THEY HAD RECEIVED DAILY POINTS OR NOT
    if($fufu_config['is_user'] == '1' && isset($_SESSION['thisUser'])){
        $ninja->db->limit_val = '1';
        $result = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."fufu_user_dailypoint",array("user_id"),array("user_id"=>$_SESSION['thisUser']['id'],"day"=>date("z"),"year"=>date("Y"))); 
        if(count($result) < 1){
            $ninja->db->dbInsert($ninja_config['TABLES_PREFIX']."fufu_user_dailypoint",array("user_id"=>$_SESSION['thisUser']['id'],"day"=>date("z"),"year"=>date("Y"))); 
            $ninja_fufu->add_point($_SESSION['thisUser']['id'],$fufu_user_config['daily_point']);
            $ninja_fufu->sendNoti($_SESSION['thisUser']['id'],sprintf($lang['up_you_earn_daily'], $fufu_user_config['daily_point']));
        }
        $_SESSION['dailypointed'] = 1;
    }
    // CHECK AND MERGE USER POINT WITH USER INFO
    if($fufu_config['is_user'] == '1' && isset($_SESSION['thisUser'])){
        $ninja->db->limit_val = '1';
        $result = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."fufu_user",array("point","badge"),array("user_id"=>$_SESSION['thisUser']['id'])); 
        if(count($result) > 0){
            $_SESSION['thisUser'] = array_merge($result[0], $_SESSION['thisUser']);
        }
    }

    // GET FUFU CATEGORY FOR FASTER CUSTOMIZATION
    $ninja->db->order_by_column = "order_id ASC, name ASC"; 
    $ninja->db->limit_val = "";
    $fufu_cat_array = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."fufu_cat",array("name","cat_id")); 
    $ninja->db->order_by_column=''; 

    // JSHINK

    include ROOT_DIR.'/ninja-applications/fufu/controllers/JShrink/Minifier.php';
    $min = new Minifier;


    // NEW FUNCTIONS

    function slug($string){
        return strtolower(trim(preg_replace('~[^0-9a-z]+~i', '-', html_entity_decode(preg_replace('~&([a-z]{1,2})(?:acute|cedil|circ|grave|lig|orn|ring|slash|th|tilde|uml);~i', '$1', htmlentities($string, ENT_QUOTES, 'UTF-8')), ENT_QUOTES, 'UTF-8')), '-'));
    }

    function rank_suffix($number){
        $ends = array('th','st','nd','rd','th','th','th','th','th','th');
        if (($number %100) >= 11 && ($number%100) <= 13) return 'th';
           return $ends[$number % 10];
    }