<?php

  include '../../../ninja-controllers/cont.main.php';

########## Google Settings.. Client ID, Client Secret from https://cloud.google.com/console #############
$google_client_id 		= trim($user_config['gg-client-id']);
$google_client_secret 	= trim($user_config['gg-client-secret']);
$google_redirect_url 	= $ninja_config['siteUrl'].'/ninja-applications/user/google/gglogin.php'; //path to your script
$google_developer_key 	= trim($user_config['gg-developer-key']);

//include google api files
require_once 'src/Google_Client.php';
require_once 'src/contrib/Google_Oauth2Service.php';

$gClient = new Google_Client();
$gClient->setApplicationName($ninja_config['siteTitle']);
$gClient->setClientId($google_client_id);
$gClient->setClientSecret($google_client_secret);
$gClient->setRedirectUri($google_redirect_url);
$gClient->setDeveloperKey($google_developer_key);

$google_oauthV2 = new Google_Oauth2Service($gClient);

//If user wish to log out, we just unset Session variable
if (isset($_REQUEST['reset'])) 
{
  unset($_SESSION['gtoken']);
  $gClient->revokeToken();
  header('Location: ' . filter_var($google_redirect_url, FILTER_SANITIZE_URL)); //redirect user back to page
}

//If code is empty, redirect user to google authentication page for code.
//Code is required to aquire Access Token from google
//Once we have access token, assign token to session variable
//and we can redirect user back to page and login.
if (isset($_GET['code'])) 
{ 
	$gClient->authenticate($_GET['code']);
	$_SESSION['gtoken'] = $gClient->getAccessToken();
	header('Location: ' . filter_var($google_redirect_url, FILTER_SANITIZE_URL));
	return;
}


if (isset($_SESSION['gtoken'])) 
{ 
	$gClient->setAccessToken($_SESSION['gtoken']);
}


if ($gClient->getAccessToken()) 
{
	  //For logged in user, get details from google using access token
	  $user 				= $google_oauthV2->userinfo->get();
	  $user_id 				= $user['id'];
	  $email 				= filter_var($user['email'], FILTER_SANITIZE_EMAIL);
      $user_name            = $ninja_user->nameFromEmail($email);
	  $profile_url 			= filter_var($user['link'], FILTER_VALIDATE_URL);
	  $profile_image_url 	= filter_var($user['picture'], FILTER_VALIDATE_URL);
	  $personMarkup 		= "$email<div><img src='$profile_image_url?sz=50'></div>";
	  $_SESSION['gtoken'] 	= $gClient->getAccessToken();
}
else 
{
	//For Guest user, get google login url
	$authUrl = $gClient->createAuthUrl();
}

//HTML page start
echo '<!DOCTYPE HTML><html>';
echo '<head>';
echo '<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />';
echo '<title>Login with Google</title>';
echo '</head>';
echo '<body>';
echo '<h1>Login with Google</h1>';

if(isset($authUrl)) //user is not logged in, show login button
{
	header('Location: ' . $authUrl);
}else{
    /* CHECK IF USER ALREADY LOGIN ONCE */
    $ninja->db->limit_val='1';
    $thisUser = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."users","",array('email'=>$email)); 
    if(count($thisUser) > 0){
        $_SESSION['uId'] = $thisUser[0]['id'];
        $_SESSION['thisUser'] = $thisUser[0];
        header("Location: ".$ninja_config['siteUrl']);
        exit;
    }else{
        $thisUserUname = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."users","",array('username'=>$user_name));
        if(count($thisUserUname) > 0){
            $user_name = uniqid();
        }
        $user_info = array('username'=>$user_name,
                'email'=>$email,
                'avatar'=>$user_config['default_avt'],
                'displayname'=>$user_name,
                'role'=>'1',
                'register_date'=>$now,
                'register_ip'=>$_SERVER['REMOTE_ADDR'],
                );
        $ninja->db->dbInsert($ninja_config['TABLES_PREFIX']."users",$user_info);
        $user_id = $ninja->db->last_insert_id; 
        $thisUser = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."users","",array('id'=>$user_id));
        $_SESSION['uId'] = $thisUser[0]['id'];
        $_SESSION['thisUser'] = $thisUser[0];
        header("Location: ".$ninja_config['siteUrl']);
        exit;
    }

}
 
echo '</body></html>';
?>

