<?php

	ob_start();
	session_start();
	error_reporting(E_ALL ^ E_NOTICE);

	/* DEFINE ROOT DIR */
	define( 'ROOT_DIR', realpath(dirname(__FILE__) . '/..') );

	/* SPECIFIC ERROR LOG FILE */
	@ini_set("log_errors" , "1");
	@ini_set("error_log" , ROOT_DIR.'/ninja-error.log');
	@ini_set("display_errors" , "0");

	/* INCLUDE IMPORTANT FILES*/
	$ninja_config = json_decode(file_get_contents(ROOT_DIR.'/ninja-configs/config.ninja.inc'), true);
	$ninja_admin = json_decode(file_get_contents(ROOT_DIR.'/ninja-configs/config.ninja-admin.inc'), true);
	$mailer_config = json_decode(file_get_contents(ROOT_DIR.'/ninja-configs/config.mailer.inc'), true);
	$ninja_config = array_merge($ninja_config, json_decode(file_get_contents(ROOT_DIR.'/ninja-configs/config.db.inc'), true));


	/*	Include classes */
	require ROOT_DIR.'/ninja-classes/PHPMailerAutoload.php';
	require ROOT_DIR.'/ninja-classes/class.db.php';
	require ROOT_DIR.'/ninja-classes/class.ninja.php';
	require ROOT_DIR.'/ninja-classes/Vendor/AltoRouter.php';

	/*  Calling object */
	$ninja = new ninja($ninja_config);

	/* GET webPath  & Set webURL */
		$parts = explode("/", $_SERVER["PHP_SELF"]);
		$key = array_search("index.php", $parts);
		if ($key !== false){ 
			$ninja->webPath = implode("/", array_slice($parts, 0, $key)); 
		}else{
			$parts = explode("/ninja-applications", $_SERVER["PHP_SELF"]);
			$ninja->webPath = $parts[0]; 
		}
		$ninja_config['siteUrl'] = str_replace('/admin', '', $ninja->webURL());
		$ninja_config['siteUrl'] = str_replace('/ninja-admin', '', $ninja_config['siteUrl']);
		$ninja->setWebURL($ninja_config['siteUrl']);

	/* Routing */
	$router = new AltoRouter();
	$router->setBasePath($ninja->webPath);

	/* INCLUDE APPLICATIONS's CONTROLLERS */
	
	$lang = array();

	// ADD USER CONTROLLERS
	if(file_exists(ROOT_DIR.'/ninja-applications/user/controllers/cont.init.php')){
		include ROOT_DIR.'/ninja-applications/user/controllers/cont.init.php';
	}

	if(isset($ninja_config['applications'])){
		foreach($ninja_config['applications'] as &$value){
			// INCLUDE MAIN CONTROLLERS
			if(!file_exists(ROOT_DIR.'/ninja-applications/'.$value.'/install')){
			 include ROOT_DIR.'/ninja-applications/'.$value.'/controllers/cont.init.php';
			}
		}
	}

	/*  Generate TOKEN for whole FORM */
	$_SESSION['token'] = '';

	/* OTHERS */

	if (ini_get("date.timezone") == "") date_default_timezone_set("GMT");
	$now = date("Y-m-d H:i:s");

	if (get_magic_quotes_gpc()) {
	    $process = array(&$_GET, &$_POST, &$_COOKIE, &$_REQUEST);
	    while (list($key, $val) = each($process)) {
	        foreach ($val as $k => $v) {
	            unset($process[$key][$k]);
	            if (is_array($v)) {
	                $process[$key][stripslashes($k)] = $v;
	                $process[] = &$process[$key][stripslashes($k)];
	            } else {
	                $process[$key][stripslashes($k)] = stripslashes($v);
	            }
	        }
	    }
	    unset($process);
	}